/* ************************************************************************
*  File: events.h                                                         *
*                                                                         *
*  Usage: structures and prototypes for events                            *
*                                                                         *
*  Written by Eric Green (ejg3@cornell.edu)                               *
*                                                                         *
*  Changes:                                                               *
*      3/6/98 ejg:  Changed return type of EVENTFUNC from void to long.   *
*                   Moved struct event definition to events.c.            *
************************************************************************ */

#define DG_EVENTFUNC(name) long (name)(void *event_obj)


/* function protos need by other modules */
void dg_event_init(void);
struct event *dg_event_create(DG_EVENTFUNC(*func), void *event_obj, long when);
void dg_event_cancel(struct event *event);
void dg_event_process(void);
long dg_event_time(struct event *event);
void dg_event_free_all(void);
