#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"

#include "comm.h"
#include "db.h"
#include "handler.h"
#include "interpreter.h"


extern int top_of_p_table;

extern int process_output(struct descriptor_data *t);


void out_rent(char *name) 
{
	FILE *fl, *fp;
	char fname[MAX_INPUT_LENGTH], fname2[MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];
	struct obj_file_elem object;
	struct obj_data *obj;
	struct rent_info rent;

	if (!get_filename(fname, sizeof(fname), CRASH_FILE, name))
		return;

	if (!(fl = fopen(fname, "rb"))) 
		return;

	sprintf(buf, "%s\r\n", fname);

	if (!feof(fl))
		fread(&rent, sizeof(struct rent_info), 1, fl);

	if (!get_filename(fname2, sizeof(fname2), NEW_OBJ_FILES, name)) {
		log("Unable to complete conversion - unable to get new object "
			 "filename.\r\n");
		return;
	}

	if (!(fp = fopen(fname2, "w+"))) {
		log("Unable to open new object file.\r\n");
		return;
	}

	fprintf(fp, "%d %d %d %d %d %d %d %d %d\r\n",
			  rent.rentcode, rent.time, rent.net_cost_per_diem,
			  rent.plat, rent.gold, rent.silver, rent.copper,
			  rent.account, rent.nitems);
	/* for rent code */

	while (!feof(fl)) {
		fread(&object, sizeof(struct obj_file_elem), 1, fl);

		if (ferror(fl) || ferror(fp)) {
			fclose(fl);
			fclose(fp);
			log("Error in conversion of rent files.");
			return;
		}

		if (!feof(fl)) {
			if (real_object(object.item_number) > 0) {
				/* none of these will be unique items. just can't happen */
				obj = read_object(object.item_number, VIRTUAL);
				my_obj_save_to_disk(fp, obj,0);
				extract_obj(obj);
			}
		}
	}
	fclose(fl);

	/* write final line - this is never actually read.. but hey! */
	fprintf(fp, "$~\n");
	fclose(fp);
}
