/****************************************************
 * Code needed for specset and related functions
 *
 * There is no reason this has to be separated from specset.c;
 * I have it this way because of several special OLC functions
 * I've made.
 ****************************************************/

/* External Functions */

/*mobs*/
SPECIAL(bank_teller);      /* For the economy stuff (see economy.c)      */
SPECIAL(butcher);          /* Converts corpses into food!                */
SPECIAL(cityguard);        /* Protect players from killers & thieves.    */
SPECIAL(cleric);           /* Casts healing magic on PCs for a fee.      */ 
SPECIAL(complainer);       /* Says annoying things and mocks PCs.        */
SPECIAL(cryogenicist);     /* Long term storage.                         */
SPECIAL(dealer_craps);     /* Gamble!                                    */
SPECIAL(dealer_high_dice); /* Gamble!                                    */
SPECIAL(dealer_seven);     /* Gamble!                                    */
SPECIAL(dealer_triples);   /* Gamble!                                    */
SPECIAL(embalmer);         /* Turns corpses into (non-rentable) bags!    */
SPECIAL(fido);             /* Eats corpses.                              */
SPECIAL(guild);            /* Let players practice their skills.         */
SPECIAL(guild_guard);      /* Block certain people from moving a given way. */
SPECIAL(janitor);          /* Picks up garbage.                          */
SPECIAL(magic_user);       /* Casts offensive spells in combat.          */
SPECIAL(mayor);            /* Moves around, says stuff, locks the gate.  */
SPECIAL(meta_phys);        /* Metaphysician - see meta.c                 */
SPECIAL(postmaster);       /* Send and receive mud mail.                 */ 
SPECIAL(puff);             /* Says annoying things.                      */
SPECIAL(receptionist);     /* Short term storage.                        */
SPECIAL(shop_keeper);      /* Sells stuff - DO NOT USE                   */
SPECIAL(snake);            /* Poisonous bite in combat.                  */
SPECIAL(temple_cleric);    /* Casts FREE healing magic on people.        */
SPECIAL(thief);            /* Steal from people in the room.             */

/*objects*/
SPECIAL(ball);             /* Magic 8-ball!                              */
SPECIAL(bank);             /* Let players deposit/withdraw money.        */
SPECIAL(blind_weapon);     /* Weapon that casts 'blindness'.             */
SPECIAL(curse_weapon);     /* Weapon that casts 'curse'.                 */
SPECIAL(fireball_weapon);  /* Weapon that casts fireballs.               */
SPECIAL(gen_board);        /* Message board.                             */
SPECIAL(portal);           /* For the portal spell                       */
SPECIAL(redbutton);        /* Teleports char to random location.         */
SPECIAL(slot_machine);     /* Gamble!                                    */

/*rooms*/
SPECIAL(dump);             /* Stuff dropped in this room disappears.     */
SPECIAL(pet_shops);        /* Buy cute, furry pets!                      */


/*
  The first spec for all categories is NULL, so these
  numbers are the actual spec. count + 1
*/
#define NUM_MOB_SPECS  26
#define NUM_OBJ_SPECS  10
#define NUM_ROOM_SPECS 3

/*
  sfunc = the function name from SPECIAL(x)
  name = what you want to have appear in lists, stats etc.
*/
struct specproc_info {
	int (* sfunc)(struct char_data *,void *,int ,char *);
	char *name;
};
